/****************************************************************************
 *		vwireless: wpusq]RTv
 *
 *			Date. 1996/01/15 -- 1996/01/15
 *				Programed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************
 *	bWCN[ht@C
 ***********************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

/***************************************
 *	VXeˑ̃CN[ht@C
 ***************************************/
#include <sys/ioctl.h>
#include <linux/ioctl.h>
#include <linux/rmc.h>

/***************************************
 *	X Toolkit WCN[ht@C
 ***************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

/*****************************************
 *	Athena Widget ̃CN[ht@C
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Paned.h>

/***************************
 *	wrbg}bvt@C
 ***************************/
#include "bitmaps/rec.xbm"
#include "bitmaps/rew.xbm"
#include "bitmaps/ff.xbm"
#include "bitmaps/play.xbm"
#include "bitmaps/stop.xbm"
#include "bitmaps/pause.xbm"

/*****************************
 *	pCN[ht@C
 *****************************/
#include "vwireless.h"

/*******************
 *	O[oϐ
 *******************/
AppData app_data;
Pixmap recPixmap, rewPixmap, ffPixmap;
Pixmap playPixmap, stopPixmap, pausePixmap;
int RemoteFd;
long int RemotePower = RMC_VTR1 | RMC_VTR_POWER;
long int RemoteRec   = RMC_VTR1 | RMC_VTR_REC;
long int RemoteRew   = RMC_VTR1 | RMC_VTR_REW;
long int RemotePlay  = RMC_VTR1 | RMC_VTR_PLAY;
long int RemoteFf    = RMC_VTR1 | RMC_VTR_FF;
long int RemoteStop  = RMC_VTR1 | RMC_VTR_STOP;
long int RemotePause = RMC_VTR1 | RMC_VTR_PAUSE;

/*********************
 *	\[XEXg
 *********************/
static XtResource resources[] = {
	{
		XtNvideoMaker,
		XtCVideoMaker,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, video_maker),
		XtRImmediate,
		(XtPointer) MAKER
	},
	{
		XtNrmcDevice,
		XtCRmcDevice,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, rmc_device),
		XtRImmediate,
		(XtPointer) "/dev/rmc0",
	},
};

/*************************************************
 *	R}hCEIvVEe[uEXg
 *************************************************/
static XrmOptionDescRec options[] = {
	{"-rmc", 	"*rmcDevice", 		XrmoptionSepArg, NULL},
	{"-maker", 	"*videoMaker", 		XrmoptionSepArg, NULL},
};

/***************************************************************************
 *	rmc_proc: R̃vZbgM𑗐M
 *	`
 *		void rmc_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				gp
 *		XtPointer client_data;	vZbgM
 *		XtPointer call_data;	gp
 *	
 *		@
 ***************************************************************************/
void rmc_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	int remoteCode;
	int error;

	remoteCode = *(long*)client_data;
	error = ioctl(RemoteFd, RMCIOCPRESET, remoteCode);
	
	if(error) {
		printf("ioctl error: %d\n", error);
	}
}

/***************************************************************************
 *	quit: IsȂR[obN֐
 *	`
 *		void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	gp
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void quit_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	close(RemoteFd);
	exit(0);
}

/***************************************************************************
 *	MakeLabelPixmaps: 
 *	`
 *		void MakeLabelPixmaps(void);
 ***************************************************************************/
void MakeLabelPixmaps(Display *display, Drawable drawable)
{
	recPixmap = XCreateBitmapFromData(display, drawable, 
						rec_bits, rec_width, rec_height);

	rewPixmap = XCreateBitmapFromData(display, drawable, 
						rew_bits, rew_width, rew_height);

	playPixmap = XCreateBitmapFromData(display, drawable, 
						play_bits, play_width, play_height);

	ffPixmap = XCreateBitmapFromData(display, 
						drawable, ff_bits, ff_width, ff_height);

	stopPixmap = XCreateBitmapFromData(display, 
						drawable, stop_bits, stop_width, stop_height);

	pausePixmap = XCreateBitmapFromData(display, 
						drawable, pause_bits, pause_width, pause_height);
}

/***************************************************************************
 *	main: C֐
 *	`
 *		int main(int argc, char **argv);
 *	
 *		int argc;		
 *		char **argv;	
 *	Ԃl
 *		
 *	
 *		@
 ***************************************************************************/
int main(int argc, char **argv)
{
	XtAppContext app_context;
	Widget topLevel;
	Widget panel, quit, power, rec, rew, play, ff, stop, pause;

	topLevel = XtVaAppInitialize(
		&app_context, 			/* Application context */
		"Vwireless", 			/* Application class */
		options, XtNumber(options), /* command line */
		&argc, argv,			/* command line args */
		NULL, 					/* for missing app-defaults file */
		NULL);					/* terminate varargs list */

	XtGetApplicationResources(topLevel, 
		&app_data, 
		resources, 
		XtNumber(resources), 
		NULL, 
		0);

	panel = XtVaCreateManagedWidget(
		"panel", 				/* arbitrary widget name */
		panedWidgetClass,		/* widget class from Form.h */
		topLevel,	 			/* parent widget */
		NULL);					/* tarminate varargs list */

	quit = XtVaCreateManagedWidget(
		"quit", 				/* widget name */
		commandWidgetClass,		/* widget class from Toggle.h */
		panel, 					/* parent widget */
		NULL);					/* tarminate varargs list */

	power = XtVaCreateManagedWidget(
		"power", 				/* widget name */
		toggleWidgetClass,		/* widget class from Toggle.h */
		panel, 					/* parent widget */
		NULL);					/* tarminate varargs list */

	rec = XtVaCreateManagedWidget(
		"rec", 					/* widget name */
		toggleWidgetClass,		/* widget class from Toggle.h */
		panel, 					/* parent widget */
		NULL);					/* tarminate varargs list */

	rew = XtVaCreateManagedWidget(
		"rew", 					/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		panel,	 				/* parent widget */
		NULL);					/* tarminate varargs list */

	play = XtVaCreateManagedWidget(
		"play", 				/* arbitrary widget name */
		toggleWidgetClass,		/* widget class from Command.h */
		panel,	 				/* parent widget */
		NULL);					/* tarminate varargs list */

	ff = XtVaCreateManagedWidget(
		"ff", 					/* arbitrary widget name */
		repeaterWidgetClass,	/* widget class from Command.h */
		panel,		 			/* parent widget */
		NULL);					/* tarminate varargs list */

	stop = XtVaCreateManagedWidget(
		"stop", 				/* arbitrary widget name */
		commandWidgetClass,		/* widget class from Command.h */
		panel,		 			/* parent widget */
		NULL);					/* tarminate varargs list */

	pause = XtVaCreateManagedWidget(
		"pause", 				/* arbitrary widget name */
		toggleWidgetClass,		/* widget class from Toggle.h */
		panel,		 			/* parent widget */
		NULL);					/* tarminate varargs list */

	RemotePower |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteRec   |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteRew   |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemotePlay  |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteFf    |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteStop  |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemotePause |= app_data.video_maker;	/* MAKER ݒ肷 */

	XawToggleChangeRadioGroup(rec, play);
	XtAddCallback(quit, XtNcallback, quit_proc, pause);
	XtAddCallback(power, XtNcallback, rmc_proc, &RemotePower);
	XtAddCallback(  rec, XtNcallback, rmc_proc, &RemoteRec);
	XtAddCallback(  rew, XtNcallback, rmc_proc, &RemoteRew);
	XtAddCallback( play, XtNcallback, rmc_proc, &RemotePlay);
	XtAddCallback(   ff, XtNcallback, rmc_proc, &RemoteFf);
	XtAddCallback( stop, XtNcallback, rmc_proc, &RemoteStop);
	XtAddCallback(pause, XtNcallback, rmc_proc, &RemotePause);

	RemoteFd = open(app_data.rmc_device, O_RDWR);
	if(RemoteFd < 0) {
		printf("unable to open %s\n", app_data.rmc_device);
		exit(1);
	}

	MakeLabelPixmaps(XtDisplay(topLevel), 
							RootWindowOfScreen(XtScreen(topLevel)));

	XtVaSetValues(  rec, XtNbitmap,   recPixmap, NULL);
	XtVaSetValues(  rew, XtNbitmap,   rewPixmap, NULL);
	XtVaSetValues( play, XtNbitmap,  playPixmap, NULL);
	XtVaSetValues(   ff, XtNbitmap,    ffPixmap, NULL);
	XtVaSetValues( stop, XtNbitmap,  stopPixmap, NULL);
	XtVaSetValues(pause, XtNbitmap, pausePixmap, NULL);

	XtRealizeWidget(topLevel);
	XtAppMainLoop(app_context);
	return(0);
}
