/****************************************************************************
 *		xwireless: wpsu^usq]RTv
 *
 *			Date. 1996/01/15 -- 1996/01/15
 *				Programed by Nobuyuki Maruichi
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************
 *	bWCN[ht@C
 ***********************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

/***************************************
 *	VXeˑ̃CN[ht@C
 ***************************************/
#include <sys/ioctl.h>
#include <linux/ioctl.h>
#include <linux/rmc.h>

/***************************************
 *	X Toolkit WCN[ht@C
 ***************************************/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

/*****************************************
 *	Athena Widget ̃CN[ht@C
 *****************************************/
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/SmeBSB.h>

/***************************
 *	wrbg}bvt@C
 ***************************/
#include <X11/bitmaps/xlogo11>
#include "bitmaps/reci.xbm"
#include "bitmaps/rec.xbm"
#include "bitmaps/rew.xbm"
#include "bitmaps/ff.xbm"
#include "bitmaps/play.xbm"
#include "bitmaps/stop.xbm"
#include "bitmaps/pause.xbm"

/*****************************
 *	pCN[ht@C
 *****************************/
#include "xwireless.h"

/*****************************************
 *	j[̑Iڂ̃}[Np̍\
 *****************************************/
typedef struct _menuPanesMarking {
	Widget rec;
	Widget panes[2];
} MenuPanesMarking;

/*******************
 *	O[oϐ
 *******************/
AppData app_data;
Pixmap reciPixmap, recPixmap, rewPixmap, ffPixmap;
Pixmap playPixmap, stopPixmap, pausePixmap, markPixmap;

int RemoteFd;
	
long int RemoteTvPower = RMC_TV1 | RMC_TV_POWER;
long int RemoteTvChUp  = RMC_TV1 | RMC_TV_CH_UP;
long int RemoteTvChDw  = RMC_TV1 | RMC_TV_CH_DOWN;
long int RemoteTvVolUp = RMC_TV1 | RMC_TV_VOL_UP;
long int RemoteTvVolDw = RMC_TV1 | RMC_TV_VOL_DOWN;
long int RemoteTvLine  = RMC_TV1 | RMC_TV_LINE;

long int RemoteVtrPower = RMC_VTR1 | RMC_VTR_POWER;
long int RemoteVtrRec   = RMC_VTR1 | RMC_VTR_REC;
long int RemoteVtrRew   = RMC_VTR1 | RMC_VTR_REW;
long int RemoteVtrPlay  = RMC_VTR1 | RMC_VTR_PLAY;
long int RemoteVtrFf    = RMC_VTR1 | RMC_VTR_FF;
long int RemoteVtrStop  = RMC_VTR1 | RMC_VTR_STOP;
long int RemoteVtrPause = RMC_VTR1 | RMC_VTR_PAUSE;
long int RemoteVtrChUp  = RMC_VTR1 | RMC_VTR_CH_UP;
long int RemoteVtrChDw  = RMC_VTR1 | RMC_VTR_CH_DOWN;

/*********************
 *	\[XEXg
 *********************/
static XtResource resources[] = {
	{
		XtNtvMaker,
		XtCMaker,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, tv_maker),
		XtRImmediate,
		(XtPointer) TVMAKER
	},
	{
		XtNvideoMaker,
		XtCMaker,
		XtRInt,
		sizeof(int),
		XtOffsetOf(AppData, video_maker),
		XtRImmediate,
		(XtPointer) VTRMAKER
	},
	{
		XtNrmcDevice,
		XtCRmcDevice,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, rmc_device),
		XtRImmediate,
		(XtPointer) "/dev/rmc0",
	},
};

/*************************************************
 *	R}hCEIvVEe[uEXg
 *************************************************/
static XrmOptionDescRec options[] = {
	{"-rmc", 		"*rmcDevice", 		XrmoptionSepArg, NULL},
	{"-tvmaker", 	"*tvMaker", 		XrmoptionSepArg, NULL},
	{"-vtrmaker", 	"*videoMaker", 		XrmoptionSepArg, NULL},
};

/***************************************************************************
 *	rmc_proc: R̃vZbgM𑗐M
 *	`
 *		void rmc_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				gp
 *		XtPointer client_data;	vZbgM
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void rmc_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	int remoteCode;
	int error;

	remoteCode = *(long*)client_data;
	error = ioctl(RemoteFd, RMCIOCPRESET, remoteCode);
	
	if(error) {
		printf("ioctl error: %d\n", error);
	}
}

/***************************************************************************
 *	MakeLabelPixmaps: 
 *	`
 *		void MakeLabelPixmaps(void);
 ***************************************************************************/
void MakeLabelPixmaps(Display *display, Drawable drawable)
{
	reciPixmap = XCreateBitmapFromData(display, drawable, 
						reci_bits, reci_width, reci_height);

	recPixmap = XCreateBitmapFromData(display, drawable, 
						rec_bits, rec_width, rec_height);

	rewPixmap = XCreateBitmapFromData(display, drawable, 
						rew_bits, rew_width, rew_height);

	playPixmap = XCreateBitmapFromData(display, drawable, 
						play_bits, play_width, play_height);

	ffPixmap = XCreateBitmapFromData(display, 
						drawable, ff_bits, ff_width, ff_height);

	stopPixmap = XCreateBitmapFromData(display, 
						drawable, stop_bits, stop_width, stop_height);

	pausePixmap = XCreateBitmapFromData(display, 
						drawable, pause_bits, pause_width, pause_height);

	markPixmap = XCreateBitmapFromData(display, 
						drawable, xlogo11_bits, xlogo11_width, xlogo11_height);
}

/***************************************************************************
 *	recLock: 
 *	`
 *		void recLock(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	gp
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void recLock(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget rec = (Widget)client_data;

	XtVaSetValues(rec, XtNbitmap, reciPixmap, NULL);
	XtSetSensitive(rec, False);
}

/***************************************************************************
 *	recUnlock: 
 *	`
 *		void recUnlock(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	gp
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void recUnlock(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget rec = (Widget)client_data;

	XtVaSetValues(rec, XtNbitmap, recPixmap, NULL);
	XtSetSensitive(rec, True);
}

/***************************************************************************
 *	quit: IsȂR[obN֐
 *	`
 *		void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	gp
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void menuMarking(Widget w, XtPointer client_data, XtPointer call_data)
{
	int counter;
	MenuPanesMarking *markInfo = (MenuPanesMarking*)client_data;

	for(counter = 0;counter < 2;++counter) {
		if((counter != 0) == XtIsSensitive(markInfo->rec)) {
			XtVaSetValues(markInfo->panes[counter], 
						XtNleftBitmap, markPixmap, NULL);
		} else {
			XtVaSetValues(markInfo->panes[counter], 
						XtNleftBitmap, None, NULL);
		}
	}
}

/***************************************************************************
 *	quit: IsȂR[obN֐
 *	`
 *		void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				EBWFbg
 *		XtPointer client_data;	gp
 *		XtPointer call_data;	gp
 *	Ԃl
 *		
 *		
 *	
 *		@
 ***************************************************************************/
void quit_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	close(RemoteFd);
	exit(0);
}

/***************************************************************************
 *	main: C֐
 *	`
 *		int main(int argc, char **argv);
 *	
 *		int argc;		
 *		char **argv;	
 *	Ԃl
 *		
 *	
 *		@
 ***************************************************************************/
void main(int argc, char **argv)
{
	XtAppContext app_context;
	Widget topLevel, panels, menuArea;
	Widget fileMenuButton, fileMenu, topSeparator;
	Widget saftyLockOn, saftyLockOff, bottomSeparator, quit;
	Widget tvTitle, tvPanel, tvPower, tvChanelDown;
	Widget tvChanelUp, tvVolumeDown, tvVolumeUp;
	Widget tvLine, vtrTitle, vtrPanel, vtrPower;
	Widget vtrRec, vtrRew, vtrPlay, vtrFf;
	Widget vtrStop, vtrPause, vtrChanelDown, vtrChanelUp;
	MenuPanesMarking menuMarkInfo;

	XtSetLanguageProc(NULL, NULL, NULL);

	topLevel = XtVaAppInitialize(
				&app_context, 			/* Application context */
				"Xwireless",
				options, XtNumber(options), /* command line */
				&argc, argv,			/* command line args */
				NULL, 					/* for missing app-defaults file */
				NULL);					/* terminate varargs list */

	XtGetApplicationResources(topLevel, 
				&app_data, 
				resources, 
				XtNumber(resources), 
				NULL, 
				0);

	panels = XtVaCreateManagedWidget(
				"panels",
				panedWidgetClass,
				topLevel,
				NULL);

	menuArea = XtVaCreateManagedWidget(
				"menuArea",
				boxWidgetClass,
				panels,
				NULL);

	fileMenuButton = XtVaCreateManagedWidget(
				"fileMenuButton",
				menuButtonWidgetClass,
				menuArea,
				XtNmenuName, "fileMenu",
				NULL);

	fileMenu = XtVaCreatePopupShell(
				"fileMenu",
				simpleMenuWidgetClass,
				fileMenuButton,
				NULL);

	topSeparator = XtVaCreateManagedWidget(
				"topSeparator",
				smeLineObjectClass,
				fileMenu,
				NULL);

	saftyLockOn = XtVaCreateManagedWidget(
				"saftyLockOn",
				smeBSBObjectClass,
				fileMenu,
				NULL);

	saftyLockOff = XtVaCreateManagedWidget(
				"saftyLockOff",
				smeBSBObjectClass,
				fileMenu,
				NULL);

	bottomSeparator = XtVaCreateManagedWidget(
				"bottomSeparator",
				smeLineObjectClass,
				fileMenu,
				NULL);

	quit = XtVaCreateManagedWidget(
				"quit",
				smeBSBObjectClass,
				fileMenu,
				NULL);

	tvTitle = XtVaCreateManagedWidget(
				"tvTitle",
				labelWidgetClass,
				panels,
				NULL);

	tvPanel = XtVaCreateManagedWidget(
				"tvPanel",
				panedWidgetClass,
				panels,
				NULL);

	tvPower = XtVaCreateManagedWidget(
				"tvPower",
				commandWidgetClass,
				tvPanel,
				NULL);

	tvChanelDown = XtVaCreateManagedWidget(
				"tvChanelDown",
				repeaterWidgetClass,
				tvPanel,
				NULL);

	tvChanelUp = XtVaCreateManagedWidget(
				"tvChanelUp",
				repeaterWidgetClass,
				tvPanel,
				NULL);

	tvVolumeDown = XtVaCreateManagedWidget(
				"tvVolumeDown",
				repeaterWidgetClass,
				tvPanel,
				NULL);

	tvVolumeUp = XtVaCreateManagedWidget(
				"tvVolumeUp",
				repeaterWidgetClass,
				tvPanel,
				NULL);

	tvLine = XtVaCreateManagedWidget(
				"tvLine",
				commandWidgetClass,
				tvPanel,
				NULL);

	vtrTitle = XtVaCreateManagedWidget(
				"vtrTitle",
				labelWidgetClass,
				panels,
				NULL);

	vtrPanel = XtVaCreateManagedWidget(
				"vtrPanel",
				panedWidgetClass,
				panels,
				NULL);

	vtrPower = XtVaCreateManagedWidget(
				"vtrPower",
				commandWidgetClass,
				vtrPanel,
				NULL);

	vtrRec = XtVaCreateManagedWidget(
				"vtrRec",
				commandWidgetClass,
				vtrPanel,
				NULL);

	vtrRew = XtVaCreateManagedWidget(
				"vtrRew",
				repeaterWidgetClass,
				vtrPanel,
				NULL);

	vtrPlay = XtVaCreateManagedWidget(
				"vtrPlay",
				commandWidgetClass,
				vtrPanel,
				NULL);

	vtrFf = XtVaCreateManagedWidget(
				"vtrFf",
				repeaterWidgetClass,
				vtrPanel,
				NULL);

	vtrStop = XtVaCreateManagedWidget(
				"vtrStop",
				commandWidgetClass,
				vtrPanel,
				NULL);

	vtrPause = XtVaCreateManagedWidget(
				"vtrPause",
				commandWidgetClass,
				vtrPanel,
				NULL);

	vtrChanelDown = XtVaCreateManagedWidget(
				"vtrChanelDown",
				repeaterWidgetClass,
				vtrPanel,
				NULL);

	vtrChanelUp = XtVaCreateManagedWidget(
				"vtrChanelUp",
				repeaterWidgetClass,
				vtrPanel,
				NULL);

	if(app_data.tv_maker & RMC_ID) {
		app_data.tv_maker |= RMC_TV1;
	}
	if(app_data.video_maker & RMC_ID) {
		app_data.video_maker |= RMC_VTR1;
	}

	RemoteTvPower |= app_data.tv_maker; /* MAKER ݒ肷 */
	RemoteTvChUp  |= app_data.tv_maker; /* MAKER ݒ肷 */
	RemoteTvChDw  |= app_data.tv_maker; /* MAKER ݒ肷 */
	RemoteTvVolUp |= app_data.tv_maker; /* MAKER ݒ肷 */
	RemoteTvVolDw |= app_data.tv_maker; /* MAKER ݒ肷 */
	RemoteTvLine  |= app_data.tv_maker; /* MAKER ݒ肷 */

	RemoteVtrPower |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrRec   |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrRew   |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrPlay  |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrFf    |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrStop  |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrPause |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrChUp  |= app_data.video_maker;	/* MAKER ݒ肷 */
	RemoteVtrChDw  |= app_data.video_maker;	/* MAKER ݒ肷 */

	menuMarkInfo.rec = vtrRec;
	menuMarkInfo.panes[0] = saftyLockOn;
	menuMarkInfo.panes[1] = saftyLockOff;

	XtAddCallback( saftyLockOn, XtNcallback, recLock, vtrRec);
	XtAddCallback(saftyLockOff, XtNcallback, recUnlock, vtrRec);
	XtAddCallback(        quit, XtNcallback, quit_proc, NULL);
	XtAddCallback(fileMenu, XtNpopupCallback, menuMarking, &menuMarkInfo);

	XtAddCallback(     tvPower, XtNcallback, rmc_proc, &RemoteTvPower);
	XtAddCallback(tvChanelDown, XtNcallback, rmc_proc, &RemoteTvChDw);
	XtAddCallback(  tvChanelUp, XtNcallback, rmc_proc, &RemoteTvChUp);
	XtAddCallback(tvVolumeDown, XtNcallback, rmc_proc, &RemoteTvVolDw);
	XtAddCallback(  tvVolumeUp, XtNcallback, rmc_proc, &RemoteTvVolUp);
	XtAddCallback(      tvLine, XtNcallback, rmc_proc, &RemoteTvLine);

	XtAddCallback(vtrPower, XtNcallback, rmc_proc, &RemoteVtrPower);
	XtAddCallback(  vtrRec, XtNcallback, rmc_proc, &RemoteVtrRec);
	XtAddCallback(  vtrRec, XtNcallback,  recLock, vtrRec);
	XtAddCallback(  vtrRew, XtNcallback, rmc_proc, &RemoteVtrRew);
	XtAddCallback( vtrPlay, XtNcallback, rmc_proc, &RemoteVtrPlay);
	XtAddCallback(   vtrFf, XtNcallback, rmc_proc, &RemoteVtrFf);
	XtAddCallback( vtrStop, XtNcallback, rmc_proc, &RemoteVtrStop);
	XtAddCallback(vtrPause, XtNcallback, rmc_proc, &RemoteVtrPause);
	XtAddCallback(vtrChanelDown, XtNcallback, rmc_proc, &RemoteVtrChDw);
	XtAddCallback(  vtrChanelUp, XtNcallback, rmc_proc, &RemoteVtrChUp);

	RemoteFd = open(app_data.rmc_device, O_RDWR);
	if(RemoteFd < 0) {
		printf("unable to open %s\n", app_data.rmc_device);
		exit(1);
	}

	MakeLabelPixmaps(XtDisplay(topLevel), 
							RootWindowOfScreen(XtScreen(topLevel)));

	if(XtIsSensitive(vtrRec)) {
		XtVaSetValues(vtrRec, XtNbitmap,  recPixmap, NULL);
	} else {
		XtVaSetValues(vtrRec, XtNbitmap, reciPixmap, NULL);
	}
	XtVaSetValues(  vtrRew, XtNbitmap,   rewPixmap, NULL);
	XtVaSetValues( vtrPlay, XtNbitmap,  playPixmap, NULL);
	XtVaSetValues(   vtrFf, XtNbitmap,    ffPixmap, NULL);
	XtVaSetValues( vtrStop, XtNbitmap,  stopPixmap, NULL);
	XtVaSetValues(vtrPause, XtNbitmap, pausePixmap, NULL);

	XtRealizeWidget(topLevel);
	XtAppMainLoop(app_context);
}

